Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-compat
BuildRequires: ant-optional
# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# If you don't want to run the unit tests
# give rpmbuild option '--without tests'

%define _without_tests 1
%define with_tests %{!?_without_tests:1}%{?_without_tests:0}
%define without_tests %{?_without_tests:1}%{!?_without_tests:0}



Summary:	JBoss Remoting
URL:		http://labs.jboss.com/portal/jbossremoting/
Source0:	jboss-remoting-1.4.3-src.tar.gz
# cvs -d:pserver:anonymous@anoncvs.forge.jboss.com:/cvsroot/jboss export -r remoting_1_4_3_GA JBossRemoting
Patch0:		jboss-remoting-1.4.1-OnewayThreadPoolForConfigurationTest.patch
Patch1:		jboss-remoting-1.4.3-build_xml.patch

Name:		jboss-remoting
Version:	1.4.3
Release:	alt1_2jpp5
Epoch:		0
License:	LGPL
Group:		Development/Java
BuildArch:	noarch
BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: ant >= 0:1.6
BuildRequires: junit
BuildRequires: jboss-jrunit
BuildRequires: batik
BuildRequires: fop
BuildRequires: saxon

BuildRequires: concurrent
BuildRequires: dom4j
BuildRequires: jakarta-commons-httpclient
BuildRequires: jakarta-commons-logging
BuildRequires: log4j
BuildRequires: tomcat5-server-lib >= 0:5.5.16-3jpp
BuildRequires: tomcat5-servlet-2.4-api
BuildRequires: jboss4-common
BuildRequires: jboss4-jmx
BuildRequires: jboss4-naming
BuildRequires: jboss-serialization
BuildRequires: jgroups
BuildRequires: jcommon
BuildRequires: jfreechart
BuildRequires: gnu-trove
BuildRequires: xml-commons-apis

Requires: jpackage-utils >= 0:1.6
Requires: jakarta-commons-httpclient
Requires: log4j
Requires: tomcat5-server-lib >= 0:5.5.16-3jpp
Requires: tomcat5-servlet-2.4-api
Requires: jboss4-common
Requires: jboss4-jmx
Requires: jboss4-naming
Requires: jboss-serialization
Requires: xml-commons-apis

%description
The purpose of JBoss Remoting is to provide a single API for most 
network based invocations and related service that uses pluggable 
transports and data marshallers. The JBoss Remoting API provides 
the ability for making synchronous and asynchronous remote calls, 
push and pull callbacks, and automatic discovery of remoting servers. 
The intention is to allow for the addition of different transports 
to fit different needs, yet still maintain the same API for making 
the remote invocations and only requiring configuration changes, 
not code changes, to fit these different needs.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
BuildArch: noarch

%description javadoc
%{summary}

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation
BuildArch: noarch

%description manual
%{summary}

%package demo
Summary:        Usage examples for %{name}
Group:          Development/Documentation

%description demo
%{summary}

%prep
%setup -q -n JBossRemoting-%{version}-src
chmod -R go=u-w *
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done

%patch0 -b .sav
%patch1 -b .sav

%build
#docs/guide/support/support/lib/avalon-framework-cvs-20020806.jar.no
#docs/guide/support/support/lib/batik.jar.no
#docs/guide/support/support/lib/fop.jar.no
#docs/guide/support/support/lib/jai_codec.jar.no
#docs/guide/support/support/lib/jai_core.jar.no
#docs/guide/support/support/lib/rowan-0.1.jar.no
#docs/guide/support/support/lib/saxon-dbxsl-extensions.jar.no
#docs/guide/support/support/lib/saxon.jar.no
pushd docs/guide/support/support/lib
build-jar-repository -s -p . \
batik \
fop \
saxon
popd
#lib/apache-commons/lib/commons-httpclient.jar.no
#lib/apache-commons/lib/commons-logging-api.jar.no
pushd lib/apache-commons/lib
ln -sf $(build-classpath commons-httpclient) .
ln -sf $(build-classpath commons-logging-api) .
popd
#lib/apache-log4j/lib/log4j.jar.no
pushd lib/apache-log4j/lib
ln -sf $(build-classpath log4j) .
popd
#lib/apache-tomcat/tomcat-apr.jar.no
#lib/apache-tomcat/tomcat-coyote.jar.no
#lib/apache-tomcat/tomcat-http.jar.no
#lib/apache-tomcat/tomcat-util.jar.no
pushd lib/apache-tomcat
ln -sf $(build-classpath tomcat5/tomcat-apr) .
ln -sf $(build-classpath tomcat5/tomcat-coyote) .
ln -sf $(build-classpath tomcat5/tomcat-http) .
ln -sf $(build-classpath tomcat5/tomcat-util) .
popd
#lib/dom4j/lib/dom4j.jar.no
pushd lib/dom4j/lib
ln -sf $(build-classpath dom4j) .
popd
#lib/jboss/jboss-common.jar.no
#lib/jboss/jboss-jmx.jar.no
#lib/jboss/jboss-serialization.jar.no
#lib/jboss/jnpserver.jar.no
#lib/jboss/jrunit.jar.no
pushd lib/jboss
ln -sf $(build-classpath jboss4/jboss-common) .
ln -sf $(build-classpath jboss4/jboss-jmx) .
ln -sf $(build-classpath jboss4/jnpserver) .
ln -sf $(build-classpath jboss-jrunit) .
ln -sf $(build-classpath jboss-serialization) .
popd
#lib/jgroups/lib/jgroups.jar.no
pushd lib/jgroups/lib
ln -sf $(build-classpath jgroups) .
#mv jgroups.jar.no jgroups.jar
popd
#lib/jrunit-libs/lib/jcommon-1.0.0-rc1.jar.no
#lib/jrunit-libs/lib/jfreechart-1.0.0-rc1.jar.no
pushd lib/jrunit-libs/lib
ln -sf $(build-classpath jcommon) .
ln -sf $(build-classpath jfreechart) .
popd
#lib/junit/lib/junit.jar.no
pushd lib/junit/lib
ln -sf $(build-classpath junit) .
popd
#lib/oswego-concurrent/lib/concurrent.jar.no
pushd lib/oswego-concurrent/lib
ln -sf $(build-classpath concurrent) .
popd
#lib/sun-servlet/lib/servlet-api.jar.no
pushd lib/sun-servlet/lib
ln -sf $(build-classpath servletapi5) servlet-api.jar
popd
#lib/trove/lib/trove.jar.no
pushd lib/trove/lib
ln -sf $(build-classpath gnu-trove) trove.jar
popd
#################################################

export ANT_OPTS="-Djava.net.preferIPv4Stack=true -Xmx128m"
export OPT_JAR_LIST="ant/ant-junit junit xalan-j2-serializer"
%if %{with_tests}
ant -Dant.build.javac.source=1.4 -Dant.build.javac.target=1.4 jars javadoc docs.generate tests
%else
ant -Dant.build.javac.source=1.4 -Dant.build.javac.target=1.4 jars javadoc docs.generate
%endif

%install

# jar
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -p -m 0644 output/lib/jboss-remoting.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# etc
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -pr output/etc   $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -pr output/lib/servlet-invoker.war   $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -p docs/JBossRemotingPushCallbacks.sxd $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr output/doc/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
install -d -m 0755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/guide
cp -pr docs/guide/build/en/*   $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/guide
install -d -m 0755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/Multiplex
cp -pr docs/Multiplex/build/en/*   $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/Multiplex
cp -p docs/multiplex.pdf   $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/Multiplex


%post javadoc
rm -f %{_javadocdir}/%{name}
ln -sf %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%{_javadir}/*
%{_datadir}/%{name}-%{version}/etc
%{_datadir}/%{name}-%{version}/servlet-invoker.war
%{_datadir}/%{name}-%{version}/JBossRemotingPushCallbacks.sxd

%files javadoc
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%doc %{_docdir}/%{name}-%{version}

%changelog
* Fri Jun 12 2009 Igor Vlasenko <viy@altlinux.ru> 0:1.4.3-alt1_2jpp5
- new version

* Sat Dec 15 2007 Igor Vlasenko <viy@altlinux.ru> 0:1.4.1-alt2_3jpp1.7
fixes jvm 5.0 poisoning

* Tue Oct 23 2007 Igor Vlasenko <viy@altlinux.ru> 0:1.4.1-alt1_3jpp1.7
- converted from JPackage by jppimport script

